Stroop - measuring reaction times to incongruent stimuli
============================================================

The experiment
------------------------

In this task subjects must report the color of the letters spelling each
word, but letters themselves also spell a color name and this may be the
same or different to the color of the letters. Stroop (1935) reports that
reaction times are slower the letters spell a color that is incongruent
with the color of the letters, indicating a compulsory automated reading of
the word.

Analyzing your data
------------------------

After you run the study, look in the data/ folder next to where the
experiment was saved. There will be an xlsx file there that can be opened
with Microsoft Excel or similar spreadsheet package. Each row represents
one condition (trial type) and each column is one variable of your experiment
or type of data collected.
Take the average of the resp.mean_rt column for the 3 congruent conditions
and compare them with the 3 incongruent conditions. In most cases the
incongruent conditions will have larger reactions times.

Notes
------------------------

This version of the Stroop effect is a very simple experiment, good for
explaining how the PsychoPy Builder interface works with minimal clutter.
You could (as a challenge) add practice trials and feedback if you liked...
or you could go to the StroopExtended version that's built in to PsychoPy's
demos menu and see how to do it there!

References
------------------------

Stroop, John Ridley (1935). "Studies of interference in serial verbal reactions". Journal of Experimental Psychology. 18 (6): 643–662.
MacLeod, CM (1991). "Half a century of research on the Stroop effect: an integrative review". Psychological Bulletin. 109 (2): 163–203.
